Public Class Form1

    Dim ballXSpeed As Single
    Dim ballYSpeed As Single

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        playerPaddle.Location = Me.PointToClient(New Point(MousePosition.X, Me.PointToScreen(playerPaddle.Location).Y))

        ball.Location = New Point(ball.Location.X + Math.Round(ballXSpeed), ball.Location.Y + Math.Round(ballYSpeed))

        'Checks that the balls X position is within the left/right edges of the paddle
        If ball.Location.X < playerPaddle.Right And ball.Location.X > playerPaddle.Left Then
            'Checks that the balls Y position is within the top/bottom edges of the paddle
            If ball.Location.Y < playerPaddle.Bottom And ball.Location.Y > playerPaddle.Top Then
                'A collision has occured
                ballYSpeed = -10
                ballXSpeed = New Random(DateTime.Now.Millisecond).Next(-10, 10)
            End If
        End If

        If ball.Location.X < computerPaddle.Right And ball.Location.X > computerPaddle.Left Then
            'Checks that the balls Y position is within the top/bottom edges of the paddle
            If ball.Location.Y < computerPaddle.Bottom And ball.Location.Y > computerPaddle.Top Then
                'A collision has occured
                ballYSpeed = 10
                ballXSpeed = New Random(DateTime.Now.Millisecond).Next(-10, 10)
            End If
        End If

        If ball.Location.X > computerPaddle.Left + 20 Then
            'Move Right
            computerPaddle.Location = New Point(computerPaddle.Location.X + 4, computerPaddle.Location.Y)
        End If
        If ball.Location.X < computerPaddle.Right - 20 Then
            'Move Left
            computerPaddle.Location = New Point(computerPaddle.Location.X - 4, computerPaddle.Location.Y)
        End If

        If ball.Location.X < 0 Then
            ballXSpeed = 5
        End If
        If ball.Location.X > Me.Width Then
            ballXSpeed = -5
        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ballXSpeed = 0
        ballYSpeed = -5
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ballYSpeed = -5
        ballXSpeed = 0
        ball.Location = New Point(Math.Round(Me.Height / 2), Math.Round(Me.Width / 2))
    End Sub
End Class
